//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  clrLimeGreen  
#property indicator_color2  clrDimGray
#property indicator_color3  clrOrange
#property indicator_color4  clrSilver
#property indicator_color5  clrLimeGreen
#property indicator_color6  clrLimeGreen
#property indicator_color7  clrOrange
#property indicator_color8  clrOrange
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_width8  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

enum enColorTypes
{
   cltZeroCross, // Color change on zero cross
   cltLevelCross // Color change on outer levels cross
};
extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT;
extern int                MomPeriod    =  14;
extern ENUM_APPLIED_PRICE MomPrice     = PRICE_CLOSE;
extern int                MinMaxPeriod =  50;
extern double             LevelUp      =  80;
extern double             LevelDown    =  20;
extern enColorTypes       ColorChangeWhen = cltZeroCross;
extern bool               Interpolate  = true;

//
//
//
//
//

double momMin[];
double momMax[];
double momLUp[];
double momLMi[];
double momLDn[];
double mom[];
double momUa[];
double momUb[];
double momDa[];
double momDb[];
double colors[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,momLUp);
   SetIndexBuffer(1,momLMi);
   SetIndexBuffer(2,momLDn);
   SetIndexBuffer(3,mom);
   SetIndexBuffer(4,momUa);
   SetIndexBuffer(5,momUb);
   SetIndexBuffer(6,momDa);
   SetIndexBuffer(7,momDb);
   SetIndexBuffer(8,momMin);
   SetIndexBuffer(9,momMax);
   SetIndexBuffer(10,colors);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" velocity fl ("+MomPeriod+","+DoubleToStr(LevelDown,2)+","+DoubleToStr(LevelUp,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { momLUp[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      if (colors[limit] ==-1) CleanPoint(limit,momDa,momDb);
      if (colors[limit] == 1) CleanPoint(limit,momUa,momUb);
      for(i=limit; i>=0; i--) 
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,MomPrice,i);
         double noise = 0, vhf = 0;
         double max   = Close[i];
         double min   = Close[i];
         for (int v=0; v<MomPeriod && (i+v+1)<Bars; v++)
         {
               noise += MathAbs(Close[i+v]-Close[i+v+1]);
               max    = MathMax(Close[i+v],max);   
               min    = MathMin(Close[i+v],min);   
         }      
         if (noise>0) vhf = (max-min)/noise;
         double tperiod  = MomPeriod;
            if (vhf>0) tperiod = -MathLog(vhf)*MomPeriod; 
         
         mom[i]    = iSsm(price,MathPow(tperiod,0.95),i,0)-iSsm(price,MathPow(tperiod,1.05),i,1);
         momMin[i] = mom[ArrayMinimum(mom,MinMaxPeriod,i)];
         momMax[i] = mom[ArrayMaximum(mom,MinMaxPeriod,i)];
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
            double range = momMax[i]-momMin[i];
               momLDn[i] = momMin[i]+range*LevelDown/100.0;
               momLMi[i] = momMin[i]+range*0.5;
               momLUp[i] = momMin[i]+range*LevelUp/100.0;
               colors[i] = colors[i+1];
               if (ColorChangeWhen==cltZeroCross)
               {
                  if (mom[i]>momLMi[i]) colors[i] =  1;
                  if (mom[i]<momLMi[i]) colors[i] = -1;
               }
               else
               {
                  colors[i] = 0;
                  if (mom[i]>momLUp[i]) colors[i] =  1;
                  if (mom[i]<momLDn[i]) colors[i] = -1;
               }
               if (colors[i] ==  1) PlotPoint(i,momUa,momUb,mom);
               if (colors[i] == -1) PlotPoint(i,momDa,momDb,mom);
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   if (colors[limit] ==-1) CleanPoint(limit,momDa,momDb);
   if (colors[limit] == 1) CleanPoint(limit,momUa,momUb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         momLUp[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen, 0,y);
         momLMi[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen, 1,y);
         momLDn[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen, 2,y);
         mom   [i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen, 3,y);
         colors[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,10,y);
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               momLUp[i+k] = momLUp[i] + (momLUp[i+n] - momLUp[i])*k/n;
               momLMi[i+k] = momLMi[i] + (momLMi[i+n] - momLMi[i])*k/n;
               momLDn[i+k] = momLDn[i] + (momLDn[i+n] - momLDn[i])*k/n;
               mom[i+k]    = mom[i]    + (mom[i+n]    - mom[i]   )*k/n;
            }
   }
   for(i=limit; i>=0; i--)
   {
      if (colors[i] ==  1) PlotPoint(i,momUa,momUb,mom);
      if (colors[i] == -1) PlotPoint(i,momDa,momDb,mom);
   }      
   return(0);
         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288

double workSsm[][4];
#define _tprice  0
#define _ssm     1

double workSsmCoeffs[][4];
#define _speriod 0
#define _sc1    1
#define _sc2    2
#define _sc3    3

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_speriod] != period)
   {
      workSsmCoeffs[instanceNo][_speriod] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_sc2] = b1;
         workSsmCoeffs[instanceNo][_sc3] = -a1*a1;
         workSsmCoeffs[instanceNo][_sc1] = 1.0 - workSsmCoeffs[instanceNo][_sc2] - workSsmCoeffs[instanceNo][_sc3];
   }
   i = Bars-i-1;

   //
   //
   //
   //
   //

      int s = instanceNo*2; 
      workSsm[i][s+_ssm]    = price;
      workSsm[i][s+_tprice] = price;
      if (i>1)
      {  
          workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_sc1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                               workSsmCoeffs[instanceNo][_sc2]*workSsm[i-1][s+_ssm]                                + 
                               workSsmCoeffs[instanceNo][_sc3]*workSsm[i-2][s+_ssm]; }
   return(workSsm[i][s+_ssm]);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}